// FILENAME:      AI_Test.cs
// AUTHORS:       [OF] Pincushion
// VERSION:       1.0
// LAST UPDATED:  Feb 19, 2000
// DESCRIPTION:
// A testing ground for AI.
//------------------------------------------------------------------------------

$missionName = "AI_Test";

exec("multiplayerStdLib.cs");

function onMissionStart()
{
	titanSounds();
}

function onMissionLoad()
{
	cdAudioCycle("SS3", "SS4", "Watching"); 
	AIMissionLoad();
}

function AIMissionLoad() {
	$AIid = 0;
	$AIpylons = "MissionGroup\\Pylons";
	$AInavDrop = "MissionGroup\\Nav Points\\NavAlpha";
	$AInavDropX = getPosition($AInavDrop, x);
	$AInavDropY = getPosition($AInavDrop, y);
	$AIpath = getObjectId("MissionGroup\\Path1");
	$AIbuilding = getObjectId("MissionGroup\\Building");
	$AIturret = getObjectId("MissionGroup\\Turret");
	$AIplayerVid = 0;
	$AInAI = 0;
	$AIorderWho = 0;
	$AIorderTarget = $AIpath;
}

function AILongName( %id ) {
	%name = getHudName(%id);
	return( %name@"("@%id@")" );
}

Pilot Reaper
{
	id = 28;
	skill = 0.8;
	accuracy = 0.8;
	aggressiveness = 0.9;
	activateDist = 10.0;
	deactivateBuff = 10.0;
	targetFreq = 4.0;
	trackFreq = 0.3;
	fireFreq = 0.3;
	LOSFreq = 0.2;
};

function AIDropPod() {
	%ix = $AInAI;
	%name = %ix;
	%vid = 30; // Emancipator
	%type = VehicleType(%vid);
	%herc = NewObject(%name, %type, %vid);
say(0,0,"NewObject name="@%name@" type="@%type@" vid="@%vid@" herc="@%herc);
	setTeam(%herc, *IDSTR_TEAM_RED);
	setPilotId(%herc,28);
	%herc.AIix = %ix;
	%x = $AInavDropX;
	%y = $AInavDropY;
	%z = getTerrainHeight(%x, %y);
	//dropPod(%x, %y, %z, %herc);
	%name = AILongName(%herc);
	//say(0,0,"Dropping "@%name@" at "@%x@","@%y@","@%z);
%z = getTerrainHeight($AInavDropX,$AInavDropY);
setPosition(%herc,$AInavDropX,$AInavDropY,%z+30);
%x = getPosition(%herc,x);
%y = getPosition(%herc,y);
%z = getPosition(%herc,z);
say(0,0,"Created "@%name@" at "@%x@","@%y@","@%z);
	$AIai[%ix] = %herc;
	$AInAI++;
	$AIorderWho = %herc;
}

function doOrder(%cmd,%arg) {
	%name = AILongName($AIorderWho);
	if ((%cmd=="Attack") || (%cmd=="Guard")) {
		%name2 = AILongName(%arg);
		say(0,0,"Order "@%name@","@%cmd@","@%name2);
		order($AIorderWho,%cmd,%arg);
	} else if ((%cmd=="Clear") || (%cmd=="Cloak") ||
			(%cmd=="HoldFire") || (%cmd=="HoldPosition") ||
			(%cmd=="Shutdown") || (%cmd=="MakeLearder")) {
		say(0,0,"Order "@%name@","@%cmd@","@%arg);
		order($AIorderWho,%cmd,%arg);
	} else if (%cmd=="Speed") {
		say(0,0,"Order "@%name@","@%cmd@","@%arg);
		order($AIorderWho,%cmd,%arg);
	}
}

function Special::structure::onScan(%nee,%ner,%more) {
	say(0,0,"Drop AI, order to Attack Building "@%more);
	AIDropPod();
	order($AIorderWho,"Attack",$AIBuilding);
}

function DropPod::structure::onScan(%nee,%ner,%more) { AIDropPod(); }

function Clear::structure::onScan(%nee,%ner,%more)
{ doOrder("Clear","True"); }

function Attack::structure::onScan(%nee,%ner,%more)
{ doOrder("Attack",$AIorderTarget); }

function Guard::structure::onScan(%nee,%ner,%more)
{ doOrder("Guard",$AIorderTarget); }

function Retreat::structure::onScan(%nee,%ner,%more)
{ doOrder("Retreat","True"); }

function ZigZag::structure::onScan(%nee,%ner,%more)
{ doOrder("ZigZag"); }

function CloakTrue::structure::onScan(%nee,%ner,%more)
{ doOrder("Cloak","True"); }
function CloakFalse::structure::onScan(%nee,%ner,%more)
{ doOrder("Cloak","False"); }

function ShutdownTrue::structure::onScan(%nee,%ner,%more)
{ doOrder("Shutdown","True"); }
function ShutdownFalse::structure::onScan(%nee,%ner,%more)
{ doOrder("Shutdown","False"); }

function HoldPositionTrue::structure::onScan(%nee,%ner,%more)
{ doOrder("HoldPosition","True"); }
function HoldPositionFalse::structure::onScan(%nee,%ner,%more)
{ doOrder("HoldPosition","False"); }

function HoldFireTrue::structure::onScan(%nee,%ner,%more)
{ doOrder("HoldFire","True"); }
function HoldFireFalse::structure::onScan(%nee,%ner,%more)
{ doOrder("HoldFire","False"); }

function SpeedLow::structure::onScan(%nee,%ner,%more)
{ doOrder("Speed","Low"); }
function SpeedMedium::structure::onScan(%nee,%ner,%more)
{ doOrder("Speed","Medium"); }
function SpeedHigh::structure::onScan(%nee,%ner,%more)
{ doOrder("Speed","High"); }

function TargetAI::structure::onScan(%nee,%ner,%more) {
	for (%i=0;%i<$AInAI;%i++) {
		%who = $AIai[%i];
		if (%who != $AIorderWho) {
			$AIorderTarget = %who;
			%name = AILongName($AIorderTarget);
			say(0,0,"Targeting AI "@%name);
			return;
		}
	}
	%name = AILongName($AIorderWho);
	say(0,0,"Targeting AI "@%name@" (self)");
	$AIorderTarget = $AIorderWho;
}

function TargetPlayer::structure::onScan(%nee,%ner,%more) {
	say(0,0,"Targeting Player"); $AIorderTarget = $AIplayerVid; }

function TargetTurret::structure::onScan(%nee,%ner,%more) {
	say(0,0,"Targeting Turret"); $AIorderTarget = $AIturret; }

function TargetBuilding::structure::onScan(%nee,%ner,%more) {
	say(0,0,"Targeting Building"); $AIorderTarget = $AIbuilding; }

function TargetPath::structure::onScan(%nee,%ner,%more) {
	say(0,0,"Targeting Path"); $AIorderTarget = $AIpath; }

function AIDestroyedMsg( %destroyed, %destroyer ) {
	%name1 = AILongName(%destroyer);
	%name2 = AILongName(%destroyed);
	Say(0,0,%name1@" destroyed "@%name2);
}

function Building::structure::onDestroyed( %destroyed, %destroyer ) {
	AIDestroyedMsg(%destroyed,%destroyer);
	healObject(%destroyed, 50000);
}

function turret::onDestroyed( %destroyed, %destroyer ) {
	AIDestroyedMsg(%destroyed,%destroyer);
	healObject(%destroyed, 50000);
}

function vehicle::onDestroyed( %destroyed, %destroyer ) {
	AIDestroyedMsg(%destroyed,%destroyer);
	%killed = playerManager::vehicleIdToPlayerNum(%destroyed);
	%killer = playerManager::vehicleIdToPlayerNum(%destroyer);
	if(%killed == 0)
	{
		// an AI died
		%i = %destroyed.AIix;
		if (%i < ($AInAI-1)) {
			$AIai[%i] = $AIai[$AInAI-1];
			$AIai[%i].AIix = %i;
		}
		$AInAI--;
		schedule( "deleteObject(" @ %destroyed @ ");", 2 );
		return;
	}
}

function vehicle::onScan(%scannee,%scanner)
{
	%player = playerManager::vehicleIdToPlayerNum(%scannee);
	if (%player) return;  // human player
	%name = AILongName(%scannee);
	Say(0,0,"Orders for "@%name@"?");
	$AIorderWho = %scannee;
}

function vehicle::onAdd(%vid)
{
	%pid = playerManager::vehicleIdToPlayerNum(%vid);
	if(%pid == 0) return;
	$AIplayerVid = %vid;
	$AIorderTarget = %vid;
}

function vehicle::onMessage(%vid, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i)
{ 
	//%pid = playerManager::vehicleIdToPlayerNum(%vid);
	//if(%pid) return;
	say(0,0,"onMessage:"@AILongName(%vid)@" "@%msg@" A="@%a);
	return;
}

// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=0;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;

function VehicleType(%v)
{
	if ((%v >= 1) && (%v < $Vn))
		%t = $Vtyp[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 3;
	else if (%v == 90) %t = 2;
	else if ((%v >= 91) && (%v <= 93)) %t = 4;
	else if ((%v >= 94) && (%v <= 96)) %t = 3;
	else if ((%v >= 110) && (%v <= 111)) %t = 4;
	else if ((%v >= 130) && (%v <= 132)) %t = 4;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 3;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;
	if (%t == 1) return "Herc";
	if (%t == 2) return "Tank";
	if (%t == 3) return "Drone";
	if (%t == 4) return "Flyer";
	return "Unknown";
}
